InMemoryTransformCronetCallback

public abstract class InMemoryTransformCronetCallback<T> extends ImplicitFlowControlCallback

Known direct subclasses
ByteArrayCronetCallback

A specialization of InMemoryTransformCronetCallback which returns the body bytes verbatim without any interpretation.

JsonCronetCallback

A specialization of InMemoryTransformCronetCallback that interprets the response body as JSON.

StringCronetCallback

A specialization of InMemoryTransformCronetCallback that interprets the response body as a string.


An abstract Cronet callback that reads the entire body to memory and optionally deserializes the body before passing it back to the issuer of the HTTP request.

The requester can subscribe for updates about the request by adding completion mListeners on the callback. When the request reaches a terminal state, the mListeners are informed in order of addition.

Parameters
<T>

the response body type

Summary

Public constructors

Public methods

ImplicitFlowControlCallback

Adds a completion listener.

Protected methods

final void

Invoked whenever part of the response body has been read.

final void

Invoked if request was canceled via cancel.

final void

Invoked if request failed for any reason after start.

final void

Invoked when the final set of headers, after all redirects, is received.

final void

Invoked when request is completed successfully.

abstract T
transformBodyBytes(UrlResponseInfo info, byte[] bodyBytes)

Transforms (deserializes) the plain full body into a user-defined object.

Inherited methods

From org.chromium.net.apihelpers.ImplicitFlowControlCallback
final void

Invoked if request was canceled via cancel.

final void
onFailed(
    UrlRequest request,
    UrlResponseInfo info,
    CronetException error
)

Invoked if request failed for any reason after start.

final void
onReadCompleted(
    UrlRequest request,
    UrlResponseInfo info,
    ByteBuffer byteBuffer
)

Invoked whenever part of the response body has been read.

final void
onRedirectReceived(
    UrlRequest request,
    UrlResponseInfo info,
    String newLocationUrl
)

Invoked whenever a redirect is encountered.

final void

Invoked when the final set of headers, after all redirects, is received.

final void

Invoked when request is completed successfully.

abstract boolean

Invoked whenever a redirect is encountered.

From org.chromium.net.UrlRequest.Callback
abstract void
onFailed(
    UrlRequest request,
    UrlResponseInfo info,
    CronetException error
)

Invoked if request failed for any reason after start.

abstract void
onReadCompleted(
    UrlRequest request,
    UrlResponseInfo info,
    ByteBuffer byteBuffer
)

Invoked whenever part of the response body has been read.

abstract void
onRedirectReceived(
    UrlRequest request,
    UrlResponseInfo info,
    String newLocationUrl
)

Invoked whenever a redirect is encountered.

Public constructors

InMemoryTransformCronetCallback

public InMemoryTransformCronetCallback()

Public methods

addCompletionListener

public ImplicitFlowControlCallback addCompletionListener(CronetRequestCompletionListener<T> listener)

Adds a completion listener. All listeners are informed when the request reaches a terminal state, in order of addition. If a listener is added multiple times, it will only be called once according to the first time it was added.

Protected methods

onBodyChunkRead

protected final void onBodyChunkRead(UrlResponseInfo info, ByteBuffer bodyChunk)

Invoked whenever part of the response body has been read. Only part of the buffer may be populated, even if the entire response body has not yet been consumed. The buffer is ready for reading. Buffers are reused internally so the implementing class shouldn't store the buffer or use it anywhere else than in the implementation of this method.

Parameters
UrlResponseInfo info

Response information.

ByteBuffer bodyChunk

The buffer that contains the received data, flipped for reading.

Throws
java.lang.Exception

if an error occurs while processing a read completion. onFailed will be called with the thrown exception set as the cause of the CallbackException.

onCanceled

protected final void onCanceled(@Nullable UrlResponseInfo info)

Invoked if request was canceled via cancel. Once invoked, no other UrlRequest.Callback methods will be invoked.

Parameters
@Nullable UrlResponseInfo info

Response information. May be null if no response was received.

onFailed

protected final void onFailed(@Nullable UrlResponseInfo info, CronetException exception)

Invoked if request failed for any reason after start. Once invoked, no other UrlRequest.Callback methods will be invoked. error provides information about the failure.

Parameters
@Nullable UrlResponseInfo info

Response information. May be null if no response was received.

CronetException exception

information about error.

onResponseStarted

protected final void onResponseStarted(UrlResponseInfo info)

Invoked when the final set of headers, after all redirects, is received. Will only be invoked once for each request. It's guaranteed that Cronet doesn't start reading the body until this method returns.

Parameters
UrlResponseInfo info

Response information.

Throws
java.lang.Exception

if an error occurs while processing response start. onFailed will be called with the thrown exception set as the cause of the CallbackException.

onSucceeded

protected final void onSucceeded(UrlResponseInfo info)

Invoked when request is completed successfully. Once invoked, no other UrlRequest.Callback methods will be invoked.

Parameters
UrlResponseInfo info

Response information.

transformBodyBytes

protected abstract T transformBodyBytes(UrlResponseInfo info, byte[] bodyBytes)

Transforms (deserializes) the plain full body into a user-defined object.

It is assumed that the implementing classes handle edge cases (such as empty and malformed bodies) appropriately. Cronet doesn't inspects the objects and passes them (or any exceptions) along to the issuer of the request.